 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red

extern string S1="ZigZag Settings";
extern int ExtDepth=12;
extern int ExtDeviation=5;
extern int ExtBackstep=3;


double HighMapBuffer[];
double LowMapBuffer[];

int level=3; // recounting's depth 
bool downloadhistory=false;
//+--------
int init() {
   SetIndexStyle(0,DRAW_ARROW,0,2);
   SetIndexArrow(0,234);
   SetIndexStyle(1,DRAW_ARROW,0,2);
   SetIndexArrow(1,234);
//---- indicator buffers mapping
   SetIndexBuffer(0,HighMapBuffer);
   SetIndexBuffer(1,LowMapBuffer);
   SetIndexEmptyValue(0,0.0);
   
   return(0);
   }

//+----
int deinit() {

 
   
   Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start() {
   
   Comment("");
 
     
       int l;
      
      
     int i, counted_bars = IndicatorCounted();
   int limit,counterZ,whatlookfor;
   int shift;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   if (counted_bars==0 && downloadhistory) // history was downloaded
     {
       ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
     }
   if (counted_bars==0) 
     {
      limit=Bars-ExtDepth;
      downloadhistory=true;
     }
   if (counted_bars>0) 
     {
      while (counterZ<level && i<100)
        {
          if (res!=0) counterZ++;
         i++;
        }
      i--;
      limit=i;
      if (LowMapBuffer[i]!=0) 
        {
         curlow=LowMapBuffer[i];
         whatlookfor=1;
        }
      else
        {
         curhigh=HighMapBuffer[i];
         whatlookfor=-1;
        }
      for (i=limit-1;i>=0;i--)  
        {
         LowMapBuffer[i]=0.0;
         HighMapBuffer[i]=0.0;
        }
     }
      
   for(shift=Bars; shift>=0; shift--)
     {
     ////
     
      val=Low[iHighest(NULL,0,MODE_HIGH,5,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[iLowest(NULL,0,MODE_LOW,5,shift)]-val)>(ExtDeviation*Point)) val=0.0;
       
        } 
      if (Low[iHighest(NULL,0,MODE_HIGH,2,shift)]==val&&l!=-1) {l=-1;LowMapBuffer[shift]=val;} else LowMapBuffer[shift]=0.0;
     // LowMapBuffer[shift]=val;
      
     ////
      //--- high
      val=High[iLowest(NULL,0,MODE_LOW,2,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[iHighest(NULL,0,MODE_HIGH,2,shift)])>(ExtDeviation*Point)) val=0.0;
       
        }
      if (High[iLowest(NULL,0,MODE_LOW,12,shift)]==val&&l!=1){ HighMapBuffer[shift]=val;l=1;} else HighMapBuffer[shift]=0.0;
     // HighMapBuffer[shift]=val;
     ////
     
     }

      
      

       return(0);
   
}

//+------------------------------------------------------------------+ 